from . import types
from typing import List, Literal


class BillingAPI:
    def __init__(self, api_token: str, environment_id: int, api_url: str = None) -> None: ...
    def ping(self): ...

    def create_user(self, unique_id: str, credit_limit: float = None, 
        first_name: str = None, last_name: str = None,
        mobile_number: str = None, work_number: str = None,
        email: str = None, company_name: str = None,
        country: str = None, city: str = None,
        address: str = None, zip_code: str = None,
        description: str = None) -> types.BillingUser: ...
    
    def update_user(self, unique_id: str, credit_limit: float = None, 
        first_name: str = None, last_name: str = None,
        mobile_number: str = None, work_number: str = None,
        email: str = None, company_name: str = None,
        country: str = None, city: str = None,
        address: str = None, zip_code: str = None,
        description: str = None) -> types.BillingUser: ...

    def get_user(self, unique_id: str) -> types.BillingUser: ...
    def get_users(self) -> List[types.BillingUser]: ...
    def deposit(self, unique_id: str, amount: float, comment: str = None) -> types.Transaction: ...
    def withdrawal(self, unique_id: str, amount: float, comment: str = None, fee_on_sender: bool = False) -> types.Transaction: ...
    def process_withdrawal(self, unique_id: str, transaction_id: int, status: bool = True) -> types.Transaction: ...
    def in_system_transfer(self, from_unique_id: str, to_unique_id: str, amount: float, comment: str = None, fee_on_sender: bool = True) -> types.Transaction: ...
    def out_system_transfer(self, unique_id: str, amount: float, comment: str = None, fee_on_sender: bool = False, service_unique_id: str = None) -> types.Transaction: ...
    def get_user_transactions(self, unique_id: str) -> List[types.Transaction]: ...
    def get_user_subscriptions(self, unique_id: str) -> List[types.Subscription]: ...
    def new_user_subscription(self, unique_id: str, plan_unique_id: str) -> types.Subscription: ...
    def set_subscription_status(self, unique_id: str, plan_unique_id: str, is_disabled: bool) -> types.Subscription: ...
    def set_subscription_count_value(self, unique_id: str, plan_unique_id: str, count: int) -> types.Subscription: ...
    def increment_subscription_count_value(self, unique_id: str, plan_unique_id: str) -> types.Subscription: ...
    def decrement_subscription_count_value(self, unique_id: str, plan_unique_id: str) -> types.Subscription: ...
    def get_out_system_service(self, service_unique_id: str) -> types.OutSystemService: ...
    def get_out_system_services(self, service_prefix: str = '') -> List[types.OutSystemService]: ...
    def create_out_system_service(self, service_unique_id: str, title: str, service_prefix: str = '', description: str = '', cost: float = None) -> types.OutSystemService: ...
    def create_subscription_plan(self, plan_unique_id: str, 
    service_unique_id: str = None, type: Literal["default", "count"] = "default",
    first_payment_amount: float = 0, amount: float = 0, days_frequency: int = 7
    ) -> types.SubscriptionPlan: ...